graph = {
    1: { '?a': 2 },
    2: { '!b': 1, '!c': 3 },
    3: { '?d': 1, '!e': 1, '?f': 4 },
    4: { '!g': 3, '!h': 5 },
    5: { '?d': 1, '!b': 1 }
}

graphTP = {
    1: { '?a': 2 },
    2: { '!c': 3 },
    3: { '?f': 4 },
    4: { '!h': 5 },
    5: {}
}
